#ifndef F_CPU
#define F_CPU 16000000UL
#endif
#include <avr/io.h>
#include <util/delay.h>
int ahour1=8;
int ahour2=0;
int amin1=12;
int amin2=4;
int hour1=8;
int hour2=0;
int min1=8;
int min2=4;
int close = 0;
char in_D(char bit)
{
    DDRD &= ~(1<<bit);
    return ((PIND & (1<<bit))>>bit);    
} 
void closeAlarm()
{
    if (!in_D(0) || !in_D(1) || !in_D(5) || !in_D(6))
    {
		close = 1;
   		PORTB = 0b00000000;
	}
}
void alarm()
{
	int temp;
    if(ahour2==hour2 && ahour1==hour1 && amin2==min2 && amin1==min1 && close == 0)
    {
		
        PORTB = 0b00100000; 
    	_delay_ms(250);
		PORTB = 0b00100001;
    	_delay_ms(250);
		PORTB = 0b00100010;
    	_delay_ms(250);
		PORTB = 0b00100100;
    	_delay_ms(250);
		PORTB = 0b00101000;
    }
}
void countTime()
{
	min1 += 4;
	if(min1 > 36)					// min 0-60
	{
		min1 = 0;
		min2 += 4;		
	}		
	if(min2 == 24)					// min = 60 -> hour+1
	{
		min1 = 0;
		min2 = 0;
		hour1 += 4;
	}	
	if(hour1 > 36)					// 09.60 -> 10.00
	{
		hour1 = 0;
		hour2 += 4;		
	}		
	if(hour2 >= 8 && hour1 >= 16)	// 24.00 -> 00.00
	{
		min1 = 0;
		min2 = 0;
		hour1 = 0;
		hour2 = 0;
	}
}
void showNum()
{
    PORTC = min1+0;				//0b00000100;
    _delay_ms(.5);
    PORTC = min2+1;				//0b00001001;
    _delay_ms(.5);
    PORTC = hour1+2;			//0b00001110;
    _delay_ms(.5);
    PORTC = hour2+3;			//0b00010011;
    _delay_ms(.5);
    PORTB = 0b00010000;			// :
    _delay_ms(.5);     
}
void reads()
{
    
    if (!in_D(0))
        {       
            PORTB ^= 0b00010001;
        }
     if (!in_D(1))
        {
            
            PORTB ^= 0b00010010;
        }
     if (!in_D(5))
        {
           
            PORTB ^= 0b00010100;
        }
     if (!in_D(6))
        {
           
            PORTB ^= 0b00011000;
        }
}
int main(void)
{
	int i; 
	uint16_t x;
    DDRB  = 0b00111111;
    DDRC  = 0b00111111;  // PC0..PC2 = Output, PC3..PC5 = Input
    DDRD  = 0b00000000;
    PORTB = 0b00000000;
    PORTC = 0b00000000;  // PC7..PC0 = 0
    PORTD = 0b01100011;   // Enable pull-up at PD0156
	while(1)
    {
		if(i >= 3000)		// 30000 loop = 1 min
		{
			countTime();
			i = 0;
		}
		i++;
		showNum();
		alarm();	
		closeAlarm();
		//read1();
	}   
   return 0;
}
//ء Դ